

c-------------------------------------------------------------------




      


c------------------------------------------------------------------------
c------------------------------------------------------------------------


      subroutine delrho(mst1, mst2, stt, msb1, msb2, stb,
     $           gf, as, cf, gs, el, mz, mw, 
     $           res1loop, res2loopgluon, res2loopgluino)

      double precision mst1, mst2, stt, ctt,  
     $                 msb1, msb2, stb, ctb, 
     $                 as, pi, gf, cf, gs, el, mw, mz, pref
      double precision oneloop, twoloop, fhff0, fhff1,
     $                 res1loop, res2loopgluon, res2loopgluino

      pi = 3.14159265358979d0
      ctt = dsqrt(1d0 - stt**2)
      ctb = dsqrt(1d0 - stb**2)
      pref = (3d0 * cf * gs**2 * el**2 * mz**2)/
     $       (2**6 * mw**2 * (mw**2 - mz**2) * pi**4)

c$$$      write(*,*) 'paramters in delrho:'
c$$$      write(*,*) 'mst1, mst2, stt, msb1, msb2, stb, gf, as'
c$$$      write(*,*) real(mst1), real(mst2), real(stt), real(msb1), 
c$$$     $           real(msb2), real(stb), real(gf), real(as),
c$$$     $           pref

      oneloop = 3d0 * gf/(8d0 * dsqrt(2d0) * pi**2) *
     $          ( - stt**2 * ctt**2 * fhff0(mst1**2, mst2**2)
     $            - stb**2 * ctb**2 * fhff0(msb1**2, msb2**2)
     $            + ctt**2 * ctb**2 * fhff0(mst1**2, msb1**2)
     $            + ctt**2 * stb**2 * fhff0(mst1**2, msb2**2)
     $            + stt**2 * ctb**2 * fhff0(mst2**2, msb1**2)
     $            + stt**2 * stb**2 * fhff0(mst2**2, msb2**2) )

      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
     $          ( - stt**2 * ctt**2 * fhff1(mst1**2, mst2**2)
     $            - stb**2 * ctb**2 * fhff1(msb1**2, msb2**2)
     $            + ctt**2 * ctb**2 * fhff1(mst1**2, msb1**2)
     $            + ctt**2 * stb**2 * fhff1(mst1**2, msb2**2)
     $            + stt**2 * ctb**2 * fhff1(mst2**2, msb1**2)
     $            + stt**2 * stb**2 * fhff1(mst2**2, msb2**2) )

      res1loop = oneloop
      res2loopgluon = twoloop

      end
