


c------------------------------------------------------------------------
c------------------------------------------------------------------------



      subroutine feynhiggsfastsub()

      implicit real*8(a-z)
      double precision mlhlle1, mlhlle2, 
     $       mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $       alphadiag1, alphadiag2, mhptree, mhp
      integer selec2,selec3
      double precision mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                 el, gf
      double precision cf, eps, pi
      complex*16 i
      double precision  MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma

      common /smpara/ mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                el, gf
      common /para/ cf, eps, pi, i
      common /susypara/ MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma
      common/higgsmass/mhh, mlh
      common /selec/selec2, selec3
      common /lle/ mlhlle1, mlhlle2,
     $             mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $             alphadiag1, alphadiag2, mhptree, mhp

c      if((dabs(mue)/1000d0 + tb/25d0).gt.2d0)then
c         write(*,*) 'WARNING - WARNING - WARNING - WARNING'
c         write(*,*) 'Mue-tan(beta) combination enforces m_b = 0'
c         write(*,*) 'WARNING - WARNING - WARNING - WARNING'
c         mb = 0.001
c      endif


      mz2 = mz**2
      mw2 = mw**2
      sw2 = 1.d0 - (mw/mz)**2
      el = dsqrt(8d0*gf*MW**2*(1-MW**2/MZ**2)/dsqrt(2d0))
      gs = dsqrt(4*pi*as)
      gmue = gf

      mb2 = mb**2

c      write(*,*) 'mtrun:', alphasmz, mt, mmz, pi
      as = alphasmz/(1d0 + (11d0 - 10d0/3d0)/(4d0*pi) * alphasmz
     $                       * dlog(mt**2/mz**2))
      mtrun = mt/(1d0 + 4d0/(3d0*pi) * as)

      if (selec2.ge.3) then
         mt = mtrun
         write(*,*) "using running top mass:", mtrun
      endif

c      if (selec3.eq.2) then
c         call def3(tb,mst2,delmst,stt,mw,mz,mt,
c     $             msusytl,msusytr,msusybl,msusybr,mtlr)
c      endif

      au = mtlr + mue/tb
      ad = mblr + mue*tb
c      ad = au
cc --> note: At = Ab is an arbitrary choice
c      mblr = ad - mue*tb


      beta = datan(tb)

      mlh2 = 0.5d0*(ma**2+mz**2 - dsqrt((ma**2+mz**2)**2 - 4.d0*
     &              mz**2*ma**2*dcos(2.d0*beta)**2))
      mlh = dsqrt(mlh2)
      Mhh2 = 0.5d0*(ma**2+mz**2 + dsqrt((ma**2+mz**2)**2 -
     &              4.d0*mz**2*ma**2*dcos(2.d0*beta)**2))
      mhh = dsqrt(mhh2)

      alpha = dacos(-dcos(2.d0*beta)*(ma**2-mz**2)/(mhh2-mlh2))/2.d0
      if (alpha.gt.0.d0) then
       alpha = -alpha
      endif

      mhptree = dsqrt(ma**2 + mw**2)

      call def2
c$$$      write(*,*) '-------------------------------------------'
c$$$      write(*,*) 'Sfermions:'
c$$$      write(*,*) 'MSt1, MSt2, stt'
c$$$      write(*,*) mst1, mst2, stt
c$$$      write(*,*) 'MSb1, MSb2, stb'
c$$$      write(*,*) msb1, msb2, stb
c$$$      write(*,*) '-------------------------------------------'

c -------------------------------------------------------------

      mtold = mt
c      write(*,*) 'vor lle'
c$$$      write(*,*) 'LLE parameters:'
c$$$      write(*,*) real(msusytl), real(msusytr), real(mtlr), real(mtold),
c$$$     $           real(mt), real(mb), real(ma), real(tb), real(gf),
c$$$     $           real(as), real(cf), real(el), real(mz), real(mw)
      call mhiggslle(msusytl, msusytr, mtlr, mblr, mtold, mt, mb,
     $               mst1, mst2, stt,
     $               ma, tb, alpha, gf, as, cf, el, mz, mw, mue,
     $               mlhlle1, mlhlle2, 
     $               mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $               alphadiag1, alphadiag2, mhp)
c      write(*,*) 'nach lle'

c -------------------------------------------------------------



 999  continue


      end
